﻿package {
	
import flash.display.Sprite;
import flash.text.TextField;
import flash.events.Event;

public class RightApp extends Sprite {

		public function RightApp() {
			
		var a:* = new StrategyBall();
		a.x = 50;
		a.y = 80;
		addChild(a);
		
		var b:* = new StrategyBall();
		b.yMotionStrategy = new AbsSineStrategy(80, 200);
		b.x = 180;
		b.y = 80;
		addChild(b);
		
		var c:* = new StrategyBall();
		c.alphaStrategy = new AbsSineStrategy(0, 1);
		c.x = 310;
		c.y = 80;
		addChild(c);
		
		var d:* = new StrategyBall();
		d.yMotionStrategy = new AbsSineStrategy(80, 200);
		d.alphaStrategy = new AbsSineStrategy(0, 1);
		d.x = 440;
		d.y = 80;
		addChild(d);
		
		addEventListener(Event.ADDED_TO_STAGE, init);
	}
	
	private function init(e:Event):void {
		stage.frameRate = 40;
	}
}
}

import flash.display.*;
import flash.events.*;

class StrategyBall extends MovieClip {
	
	public var yMotionStrategy:NumberSequenceStrategy;
	public var alphaStrategy:NumberSequenceStrategy;
	
	function StrategyBall() {
		graphics.beginFill(0xAA0000);
		graphics.drawCircle(0, 0, 20);
		graphics.endFill();
		addEventListener(Event.ENTER_FRAME, handleEnterFrame);
	}
	
	private function handleEnterFrame(e:Event):void {
		if (yMotionStrategy != null) {
			y = yMotionStrategy.nextValue();
		}
		if (alphaStrategy != null) {
			alpha = alphaStrategy.nextValue();
		}
	}
}
interface NumberSequenceStrategy {
	function nextValue():Number;
}
class AbsSineStrategy implements NumberSequenceStrategy {
	
	private var frame:int = 0;
	private var from:Number;
	private var to:Number;
	
	public function AbsSineStrategy(from:Number, to:Number) {
		this.from = from;
		this.to = to;
	}
	
	public function nextValue():Number {
		frame++;
		return to + Math.abs(Math.sin(frame / 15)) * (from - to);
	}
}




















